//---------------------------------------------------------------------------
//		Borland C++ Builder	msec  ߰	ްޮ 0.01	1997.11.02
//		Copyright (c) 1997  N.Nakashima					쐬	1997.11.02
//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <Consts.hpp>
#include <MMSystem.hpp>
#include <Controls.hpp>
#include <SysUtils.hpp>
#pragma hdrstop

#include "MsTimer.h"
//---------------------------------------------------------------------------
static inline TMsTimer *ValidCtrCheck()
{
	return new TMsTimer(NULL);
}
//---------------------------------------------------------------------------
static void __stdcall MsTimeProc(UINT uTimerID, UINT uMsg, DWORD dwUser,
								 DWORD dwReserved1, DWORD dwReserved2)
{
	((TMsTimer *)dwUser)->Timer();			// ϥĂ̌Ăяo
}

__fastcall TMsTimer::TMsTimer(TComponent* Owner)
	: TComponent(Owner)
{
	FEnabled  = true;
	FInterval = 1000;
	FTimerID  = 0;
}

__fastcall TMsTimer::~TMsTimer(void)
{
	FEnabled = false;
	UpdateTimer();
//	inherited Destroy;
}

void __fastcall TMsTimer::Loaded(void)		// èlǂݍ݌̏
{
	inherited Loaded();
	UpdateTimer();
}

void __fastcall TMsTimer::UpdateTimer(void)
{
	if (FTimerID) {
		timeKillEvent(FTimerID);			// ϥޯĂ̔j
		FTimerID = 0;
	}
	if (FEnabled && FInterval && FOnTimer) {
		FTimerID = timeSetEvent(FInterval, FInterval, // ϥޯĂ̐ݒ
								MsTimeProc, (DWORD)this, TIME_PERIODIC);
		if (!FTimerID)
			throw new EOutOfResources(SNoTimers);
	}
}

void __fastcall TMsTimer::SetEnabled(bool Value)
{
	if (FEnabled != Value) {
		FEnabled = Value;
		UpdateTimer();
	}
}

void __fastcall TMsTimer::SetInterval(Cardinal Value)
{
	if (FInterval != Value) {
		FInterval = Value;
		UpdateTimer();
	}
}

void __fastcall TMsTimer::SetOnTimer(Classes::TNotifyEvent Value)
{
	FOnTimer = Value;
	UpdateTimer();
}

void __fastcall TMsTimer::Timer(void)
{
	if (FOnTimer)
		FOnTimer(this);
}
//---------------------------------------------------------------------------
namespace Mstimer							// ߰ēo^
{
	void __fastcall Register()
	{
		TComponentClass classes[1] = {__classid(TMsTimer)};
		RegisterComponents("Timer", classes, 0);
	}
}
//---------------------------------------------------------------------------
