//---------------------------------------------------------------------------
//		Borland C++ Builder	msec  ߰ ̧ͯ
//		Copyright (c) 1997  N.Nakashima
//----------------------------------------------------------------------------
#ifndef MsTimerH
#define MsTimerH
//----------------------------------------------------------------------------
#include <Classes.hpp>
#include <Windows.hpp>
#include <System.hpp>
namespace Mstimer
{
//-- type declarations -------------------------------------------------------
class TMsTimer;
class TMsTimer : public Classes::TComponent
{
	typedef Classes::TComponent inherited;

private:
	UINT	 FTimerID;					// ϥĎʺ
	bool	 FEnabled;					// ϥċ
	Cardinal FInterval;					// ώ (msec)
	Classes::TNotifyEvent FOnTimer;		// ϥ
	void __fastcall UpdateTimer(void);
	void __fastcall SetEnabled(bool Value);
	void __fastcall SetInterval(Cardinal Value);
	void __fastcall SetOnTimer(Classes::TNotifyEvent Value);

public:	// protected:	عݎgps
	virtual void __fastcall Timer(void);
protected:
	virtual void __fastcall Loaded(void);

public:
	__fastcall virtual TMsTimer(Classes::TComponent* AOwner);
	__fastcall virtual ~TMsTimer(void);

__published:
	__property bool Enabled = {read=FEnabled, write=SetEnabled, default=true};
	__property Cardinal Interval = {read=FInterval, write=SetInterval, default=1000};
	__property Classes::TNotifyEvent OnTimer = {read=FOnTimer, write=SetOnTimer};
};

//-- var, const, procedure ---------------------------------------------------
extern void __fastcall Register(void);

}	/* namespace Mstimer */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Mstimer;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// MsTimer
