//---------------------------------------------------------------------------
#include <vcl\vcl.h>
#include <MMSystem.hpp>
#pragma hdrstop

#include "MainUnit.h"
//---------------------------------------------------------------------------
#pragma link "mstimer"
#pragma resource "*.dfm"
TMainForm *MainForm;
//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
DWORD dwStartMsec;						// Jnoߎ (msec)
DWORD dwTimerCount;						// Timer߰ Đ
DWORD dwMsTimerCount;					// MsTimer߰ Đ

void __fastcall TMainForm::FormActivate(TObject *Sender)
{
	dwStartMsec		= timeGetTime();		// Jnoߎ (msec)
	dwTimerCount	= 0;					// Timer߰ Đ
	dwMsTimerCount	= 0;					// MsTimer߰ Đ
	TimerUpDown->Position	 = (short)Timer1->Interval;
	MsTimerUpDown->Position	 = (short)MsTimer1->Interval;
	SetTimerLabel->Caption	 = IntToStr(Timer1->Interval)   + "msec";
	SetMsTimerLabel->Caption = IntToStr(MsTimer1->Interval) + "msec";
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::DispTimerTimer(TObject *Sender)
{
	DWORD dwElapsedMsec, dwTimerMsec, dwMsTimerMsec; // oߎ (msec)
	double dTimerInterval, dMsTimerInterval;		 // ώ  (msec)

	if (!dwMsTimerCount || !dwTimerCount)
		return;
	dwElapsedMsec	 = timeGetTime() - dwStartMsec;				// oߎ (msec)
	dMsTimerInterval = (double)dwElapsedMsec / dwMsTimerCount;	// ώ  (msec)
	dwMsTimerMsec	 = dwMsTimerCount * MsTimer1->Interval;		// oߎ (msec)
	dTimerInterval	 = (double)dwElapsedMsec / dwTimerCount;	// ώ  (msec)
	dwTimerMsec		 = dwTimerCount * Timer1->Interval;			// oߎ (msec)
	ElapsedLabel->Caption = IntToStr(dwElapsedMsec) + "msec";
	TimerLabel->Caption   = IntToStr(dwTimerMsec)   + "msec 덷 " +
							IntToStr(dwTimerMsec   - dwElapsedMsec);
	MsTimerLabel->Caption = IntToStr(dwMsTimerMsec) + "msec 덷 " +
							IntToStr(dwMsTimerMsec - dwElapsedMsec);
	MeasureMsTimerLabel->Caption = FloatToStrF(dMsTimerInterval, ffFixed, 15, 2) + "msec";
	MeasureTimerLabel->Caption   = FloatToStrF(dTimerInterval, ffFixed, 15, 2) + "msec";
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::Timer1Timer(TObject *Sender)
{
	++dwTimerCount;						// Timer߰ Đ
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::MsTimer1Timer(TObject *Sender)
{
	++dwMsTimerCount;						// MsTimer߰ Đ
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::TimerUpDownClick(TObject *Sender, TUDBtnType Button)
{
	Timer1->Interval = ((TUpDown *)Sender)->Position;
	SetTimerLabel->Caption = IntToStr(Timer1->Interval) + "msec";
	dwStartMsec	   = timeGetTime();			// Jnoߎ (msec)
	dwTimerCount   = 0;						// Timer߰ Đ
	dwMsTimerCount = 0;						// MsTimer߰ Đ
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::MsTimerUpDownClick(TObject *Sender, TUDBtnType Button)
{
	MsTimer1->Interval = ((TUpDown *)Sender)->Position;
	SetMsTimerLabel->Caption = IntToStr(MsTimer1->Interval) + "msec";
	dwStartMsec	   = timeGetTime();			// Jnoߎ (msec)
	dwTimerCount   = 0;						// Timer߰ Đ
	dwMsTimerCount = 0;						// MsTimer߰ Đ
}
//---------------------------------------------------------------------------